
function DivPopup(popup_id, popup_class,
                  inner_panel_id, inner_panel_class,
                  blank_panel_id,
                  panel_class
                 )
{
    this.m_Popup_id = popup_id;
    this.m_Popup_class = popup_class;

    this.m_Inner_panel_id = inner_panel_id;
    this.m_Inner_panel_class = inner_panel_class;

    this.m_Blank_panel_id = blank_panel_id;
    this.m_Panel_class = panel_class;

    this.SetOffsets(0, 60);
}


DivPopup.s_Popup_id_list = new Array();


DivPopup.AddPopup = function(popup)
{
    DivPopup.s_Popup_id_list.push(popup);
}


DivPopup.RemovePopup = function(popup)
{
    // remove popup_id from s_Popup_id_list
    var notPanel = function(element, index, array) {
        return element != popup;
    };
    DivPopup.s_Popup_id_list = ArrFilter(DivPopup.s_Popup_id_list, notPanel);
}


DivPopup.CloseLastPopup = function()
{
    if (DivPopup.s_Popup_id_list.length > 0) {
        DivPopup.s_Popup_id_list.pop().Close();
    }
}


DivPopup.SetPos = function(e, x, y)
{
    setprop(e, 'left', x);
    setprop(e, 'top', y);
}


DivPopup.SetVisibility = function(e, vis)
{
    var v = vis ? 'visible' : 'hidden';
    setprop(e, 'visibility', v);
/*
    e.style.visiblity = v;
*/
}


DivPopup.prototype.SetOffsets = function(xoffset, yoffset)
{
    // xoffset: offset from the right side (use negative numbers to move left)
    // yoffset: offset from the top

    this.m_Xoffset = xoffset;
    this.m_Yoffset = yoffset;
};


DivPopup.prototype.ToggleDiv = function(val, idlist)
{
    var p = document.getElementById(this.m_Popup_id);
    if (!p) {
        return null
    }

    var from_panels = getElementsByIdPrefix(document, 'div', 'scratch', 'scratch')
    var panel_to = document.getElementById(this.m_Inner_panel_id);

    var new_nodes = new Array();
    var scratch_panel;

    while (id = idlist.shift()) {
        var n = getElementsByIdPrefix(document, 'div', this.m_Panel_class, id).shift();

        if (!n) {
            alert('Node not found: ' + id);
            continue;
        }

        // check that node is not already in destination
        var in_dest = n.parentNode == panel_to;

        panel_from = n.parentNode;

        if (!(panel_from || in_dest)) {
            alert('Node not found in scratch or dest panels: ' + id)
            continue;
        }

        // ensure idlist is an array
        if (!(idlist instanceof Array)) {
            idlist = [ idlist ];
        }

    // populate destination - move elements from panel_from to panel_to
        new_nodes.push(n);
        if (!in_dest) {
            panel_from.removeChild(n);
            scratch_panel = panel_from;
        }
    }

    if (new_nodes.length > 0 && scratch_panel) {
        // clear destination - move elements in specified class
        // from panel_to to panel_from
        var pclass = this.m_Panel_class;
        var hasClassName = function(element, index, array) {
            return element.className && element.className == pclass;
        };
        var chldlist = ArrFilter(panel_to.childNodes, hasClassName);
        if (chldlist) {
            while (child = chldlist.shift()) {
                panel_to.removeChild(child);
                scratch_panel.appendChild(child);
            }
        }

        while (node = new_nodes.shift()) {
            panel_to.appendChild(node);
        }
    }


    DivPopup.SetVisibility(p, val);

    return p;
}


DivPopup.prototype.Show = function(idlist)
{
    DivPopup.AddPopup(this);
    var el = this.ToggleDiv(true, idlist);
    if (!el) {
        return;
    }

    var x = document.body.clientWidth + document.body.scrollLeft - el.clientWidth + this.m_Xoffset;
    var y = this.m_Yoffset + document.body.scrollTop;

    DivPopup.SetPos(el, x, y);
}


DivPopup.prototype.Close = function()
{
    DivPopup.RemovePopup(this);
    this.ToggleDiv(false, [this.Blank_panel_id]);
}

