/*==================================================
 *  XmlHttp Utility Functions
 *==================================================
 */

function CachedXmlHttp()
{
    // cache for additional placements html
    this.m_Cache = new Array();
}

CachedXmlHttp.prototype = new XmlHttp();


CachedXmlHttp.prototype.GetCacheValue = function(key)
{
    return this.m_Cache[key];
};


CachedXmlHttp.prototype.SetCacheValue = function(key, val)
{
    this.m_Cache[key] = val;
};


/*
 *  Check cache for requested url. Only retrieve from URL on cache miss.
 */
CachedXmlHttp.prototype.Get = function(url, fError, fDone)
{
    var val = this.GetCacheValue(url);
    if (val) {
        XmlHttp.s_OnReadyStateChange(val, fError, fDone);
        return;
    }

    /*
     * perform XmlHttp retrieval
     */
    var xmlhttp = this.x_ProcessRequest("GET", url, null, fError, fDone);
};

CachedXmlHttp.prototype.x_RequestCompleted = function(url, xmlhttp)
{
    this.SetCacheValue(url, xmlhttp);
};

